<?php
/**
* @version		$Id: loadmodule.php 14401 2010-01-26 14:10:00Z louis $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2010 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent( 'onPrepareContent', 'plgContentLoadSoundcloud' );

/**
* Plugin that loads module positions within content
*/
function plgContentLoadSoundcloud( &$row, &$params, $page=0 )
{
	$db =& JFactory::getDBO();
	// simple performance check to determine whether bot should process further
	if ( JString::strpos( $row->text, 'http://soundcloud.com/' ) === false ) {
		return true;
	}

	// Get plugin info
	$plugin				=& JPluginHelper::getPlugin('content', 'loadsoundcloud');
	$pluginParams 		= new JParameter( $plugin->params );
 	$mode				= $pluginParams->def('mode',1);
	 $player_height		= $pluginParams->def('player_height','200');
	$auto_play			= $pluginParams->def('auto_play',0);
	$show_comments		= $pluginParams->def('show_comments',1);
	$showdescription		= $pluginParams->def('showdescription',1);
	$color				= $pluginParams->def('color','3B5998');
	if($auto_play==0) $auto_play = 'false';
	elseif($auto_play==1) $auto_play = 'true';
	if($show_comments==0) $show_comments = 'false';
	elseif($show_comments==1) $show_comments = 'true';

	
	if($mode==1)
		$regex			= '/{http:\/\/soundcloud.com\/+(.*?)}/i';   //{http://soundcloud.com/blabla/moi}
	elseif($mode==2)
		$regex			= '/http:\/\/soundcloud.com\/+(.*?)\s/i'; //http://soundcloud.com/blabla/moi
	elseif($mode==3)
		$regex			= '/{soundcloud\s+(.*?)}/i';   //{http://soundcloud.com/blabla/moi}
	elseif($mode==4)
		$regex			= '/{source}http:\/\/soundcloud.com\/+(.*?){\/source}/i';

 $matches	= array();
		// find all instances of plugin and put in $matches
		preg_match_all($regex, $row->text, $matches, PREG_SET_ORDER);

		foreach ($matches as $match) {
			//if(substr_count($match[1] ,'/')==1)
				//$player_height='81';
			// $match[0] is full pattern match, $match[1] is the position
			$output = _load($match[1],$mode,$player_height,$auto_play,$show_comments,$color,$theme_color);
			// We should replace only first occurrence in order to allow positions with the same name to regenerate their content:
			$row->text = preg_replace("|$match[0]|", $output, $row->text, 1);
	}
}

function _load($url,$mode,$player_height,$auto_play,$show_comments,$showdescription,$color,$theme_color)
	{
		$url=urlencode($url);
		
		//echo $mode;
	
						
		$html = '<div>';
		
		$zurl = 'http://soundcloud.com/oembed?url=http%3A//soundcloud.com/'.$url;
		if( $auto_play == 1)
				$zurl =  $zurl."&auto_play=true";
		else
				$zurl =  $zurl."&auto_play=false";
		if( $show_comments)
				$zurl =  $zurl."&show_comments=true";
		else
				$zurl =  $zurl."&show_comments=false";
		$color	= trim($color);
		if( !empty($color))
				$zurl .= "&color=".$color;
		$zurl .= "&maxheight=".$player_height ;
		$result =   simplexml_load_file($zurl);
		if( $showdescription )
				$html .= $result->description;
		 $html .= $result->html;
		$html .= '</div>';
		$return = $html;
		
		
		return $return;
	}